例外処理

  Java コンパイラでは,各コンストラクタとメソッドをチェックし,生成される例外の種類を確認します.プログラムでは,RuntimeException クラス及びそのサブクラスを除く,Exception クラスの全サブクラスに対して(ユーザが作成した独自の例外も含む),捕捉(その例外に対する処理を行う)または宣言(呼び出されたメソッドに例外を引き渡す)する必要があります.例えば,下に示す例において IOException や Negative に対する処理は必ず行わなければなりませんが,ArithmeticException や ArrayIndexOutOfBoundsException に対する処理は必ずしも必要ありません.処理を記述しない場合は,規定の例外ハンドラが呼び出され,例外メッセージが表示され,プログラムの実行が停止されます.

  例外が発生すると,try ブロックの後ろに記述された catch ブロックにその例外に対応した catch ブロックが存在するか否かを検索します.もし存在すれば,その catch ブロック内に記述された処理を実行します.もし存在しなかった場合は( try ブロックが記述されていない場合も含む),そのメソッドを呼び出したメソッドを遡って順に検索します.main メソッドまで遡っても対応する catch ブロックが存在しない場合は,規定の例外ハンドラが呼び出され,例外メッセージが表示され,プログラムの実行が停止されます.ただし,メソッドを遡るためには,以下の例に示すように,throw または throws によって,対応する例外が投げられて(引き渡されて)いる必要があります.
001	/****************************/
002	/* 例外処理                 */
003	/*      coded by Y.Suganuma */
004	/****************************/
005	import java.io.*;
006	
007	/******************/
008	/* 独自の例外処理 */
009	/******************/
010	class Negative extends Exception {
011		double x, y;
012	
013		Negative(String str, double x, double y) {
014			super(str);
015			this.x = x;
016			this.y = y;
017		}
018	
019		void message(int sw) {
020			if (sw == 0)
021				System.out.println("    1 番目の値を正にして再実行しました");
022			else
023				System.out.println("    データを修正してください");
024		}
025	}
026	
027	/**************************************/
028	/* mainメソッドを含むクラスTestの定義 */
029	/**************************************/
030	public class Test {
031				// main
032		public static void main (String[] args) throws IOException
033		{
034						// try ブロック
035			try {
036				BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
037				System.out.print("0:平方根,1:除算,2:配列? ");
038				int sw = Integer.parseInt(in.readLine());
039								// (x + y) の平方根
040				if (sw == 0) {
041					System.out.print("1 つ目のデータは? ");
042					double x = Double.parseDouble(in.readLine());
043					System.out.print("2 つ目のデータは? ");
044					double y = Double.parseDouble(in.readLine());
045					sq(x, y);
046				}
047								// x / y
048				else if (sw == 1) {
049					System.out.print("1 つ目のデータは? ");
050					int x = Integer.parseInt(in.readLine());
051					System.out.print("2 つ目のデータは? ");
052					int y = Integer.parseInt(in.readLine());
053					div(x, y);
054				}
055								// 配列への代入
056				else
057					input();
058			}
059						// 独自の例外に対する処理
060			catch (Negative ng)
061			{
062				System.out.println(ng.getMessage());
063				ng.printStackTrace();
064				if (ng.y > 0.0) {
065					ng.message(0);
066					try {
067						sq(-ng.x, ng.y);
068					}
069					catch (Negative ng1) {}
070				}
071				else
072					ng.message(1);
073			}
074						// 0 による除算に対する処理
075			catch (ArithmeticException ar)
076			{
077				System.out.println(ar.getMessage());
078				ar.printStackTrace();
079				System.out.println("0 による除算");
080			}
081						// finally ブロック(常に実行)
082			finally
083			{
084				System.out.println("---method main---");
085			}
086		}
087				// (x + y) の平方根
088		static void sq(double x, double y) throws Negative
089		{
090			if (x < 0.0 && y < 0.0)
091				throw new Negative("両方とも負", x, y);
092			else if (x < 0.0 || y < 0.0)
093				throw new Negative("片方が負", x, y);
094	
095			double z = Math.sqrt(x+y);
096			System.out.println("平方根 " + z);
097		}
098				// x / y
099		static void div(int x, int y)
100		{
101			try {
102				int z = x / y;
103				System.out.println("除算 " + z);
104			}
105						// 0 による除算に対する処理
106			catch (ArithmeticException ar)
107			{
108				throw ar;
109			}
110			finally
111			{
112				System.out.println("---method div---");
113			}
114		}
115				// 何番目の要素に代入するのか
116		static void input() throws IOException
117		{
118			BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
119			System.out.print("何番目の要素に代入? ");
120			int n = Integer.parseInt(in.readLine());
121			try {
122				set(n);
123			}
124						// 配列の外への代入
125			catch (ArrayIndexOutOfBoundsException e)
126			{
127				System.out.println(e.getMessage());
128				e.printStackTrace();
129				System.out.println("要素番号が不適当");
130			}
131			finally
132			{
133				System.out.println("---method input---");
134			}
135		}
136				// 代入の実行
137		static void set(int n) throws ArrayIndexOutOfBoundsException
138		{
139			int a[] = new int [5];
140			a[n] = 10;
141			System.out.println("a[" + n + "] = 10");
142		}
143	}
		
010 行目~ 025 行目

  ユーザ独自の例外の定義です.必ず,Exception クラスを継承する必要があります.014 行目では,メッセージを引数として,スーパークラスのコンストラクタを呼んでいます.

032 行目

  IOException は,RuntimeException クラスのサブクラスではないため,捕捉または宣言する必要があります.IOException は,116 行目の input メソッドにおいても発生する可能性がありますが,throws によって投げられています.従って,main メソッドにおいて対応する処理を行う必要がありますが,main メソッドにおいても throws によって投げています.従って,このプログラムの場合は,規定の例外ハンドラの処理に任されることになります.もし,main メソッドに,
	catch (IOException io)
	{
		・・・(何も処理を行わなくても良い)
	}
			
のような catch ブロックを記述しておけば,この行の throws 以下は必要ありません.今まで示した Java プログラムの多くの例では,この方法を使用してきました.

035 行目~ 058 行目

  この try ブロックの中では,Negative,ArithmeticException,ArrayIndexOutOfBoundsException,または,IOException 例外が発生する可能性があります.先に述べたように,IOException に関しては,032 行目の throws によってシステムに投げているため,このプログラムでは具体的な処理を行っていません.

060 行目~ 073 行目

  ユーザ独自の例外 Negative が発生した場合は,この catch ブロックで捕捉し,処理を実行します.062 行目では,Throwable クラス( Exception クラスのスーパークラス)のメソッド getMassage を使用し,014 行目においてスーパークラスに渡したメッセージを出力しています.printStackTrace メソッドは,getMessage メソッドと同様,Throwable クラスのメソッドであり,例外が発生した時点におけるスタック情報を出力します.なお,064 行目~070 行目では,1 番目の変数だけが負である場合,それを正の値に修正し,平方根の計算を再実行しています.

075 行目~ 080 行目

  ArithmeticException 例外が発生した場合は,この catch ブロックで捕捉し,処理を実行します.メソッド div の中に記述された catch ブロック内で処理可能ですが,107 行目の throw 文によってこのメソッドに投げられているため,ここでの処理が必要になります.

082 行目~ 085 行目

  finally ブロックは,例外が起きても起きなくても,常に実行されます.必要が無ければ,記述しなくても構いません.

088 行目~ 097 行目

  平方根を計算するメソッドです.指定された条件の時,ユーザ独自の例外 Negative を発生させ,その例外を,088 行目の throws によって,このメソッドを呼び出したメソッド(この例では,main メソッド)に投げています.その結果,main メソッドの 060 行目~ 073 行目において,具体的な処理が実行されます.なお,例外を発生させたメソッドの中に,try 及び catch ブロックを記述し,その処理を行わせることは出来ません.

099 行目~ 114 行目

  除算を行うメソッドです.102 行目の演算によって例外が発生した場合は,108 行目の throw 文によって,呼び出したメソッド(この例では,main メソッド)に投げられます.

116 行目~ 135 行目

  IOException に関しては,throws によって,呼び出したメソッド(この例では,main メソッド)に投げているため,try ブロックには入れてありません.また,ArrayIndexOutOfBoundsException に関しては,set メソッドの 140 行目で発生する可能性があるのですが,set メソッドが 137 行目の throws によって,呼び出したメソッド(この例では,input メソッド)に投げているため,ここで処理を行っています.このメソッドの catch ブロックにおいて ArrayIndexOutOfBoundsException に対する処理を行っているため,さらに上のメソッドに投げる必要はありません.

137 行目~ 142 行目

  大きさが 5 である配列に対して,a[n] = 10 の処理を行っています.従って,n の値が 0 未満,または,5 以上の時は,この文の実行により ArrayIndexOutOfBoundsException 例外が発生します.ただし,その処理は,137 行目の throws によって,呼び出したメソッド(この例では,input メソッド)に投げているため,ここでは何も行っていません.

  このプログラムを実行すると,各入力データに対して,以下に示すような結果が得られます.なお,以下に示す結果には入力促進文も含まれています.
+++++ 平方根,例外発生せず
	0:平方根,1:除算,2:配列? 0
	1 つ目のデータは? 1
	2 つ目のデータは? 2
	平方根 1.7320508075688772
	---method main---
+++++ 平方根,1 番目のデータが負
	0:平方根,1:除算,2:配列? 0
	1 つ目のデータは? -1
	2 つ目のデータは? 2
	片方が負
	Negative: 片方が負
	        at Test.sq(Test.java:93)
	        at Test.main(Test.java:45)
	    1 番目の値を正にして再実行しました
	平方根 1.7320508075688772
	---method main---
+++++ 平方根,2 つのデータが負
	0:平方根,1:除算,2:配列? 0
	1 つ目のデータは? -1
	2 つ目のデータは? -2
	両方とも負
	Negative: 両方とも負
	        at Test.sq(Test.java:91)
	        at Test.main(Test.java:45)
	    データを修正してください
	---method main---
+++++ 除算,例外発生せず
	0:平方根,1:除算,2:配列? 1
	1 つ目のデータは? 12
	2 つ目のデータは? 3
	除算 4
	---method div---
	---method main---
+++++ 除算,例外発生
	0:平方根,1:除算,2:配列? 1
	1 つ目のデータは? 12
	2 つ目のデータは? 0
	---method div---
	/ by zero
	java.lang.ArithmeticException: / by zero
	        at Test.div(Test.java:102)
	        at Test.main(Test.java:53)
	0 による除算
	---method main---
+++++ 配列,例外発生せず
	0:平方根,1:除算,2:配列? 2
	何番目の要素に代入? 3
	a[3] = 10
	---method input---
	---method main---
+++++ 配列,例外発生
	0:平方根,1:除算,2:配列? 2
	何番目の要素に代入? -1
	-1
	java.lang.ArrayIndexOutOfBoundsException: -1
	        at Test.set(Test.java:140)
	        at Test.input(Test.java:122)
	        at Test.main(Test.java:57)
	要素番号が不適当
	---method input---
	---method main---